package edu.psu.geovista.datamining.util;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class MathUtil {
  public static void normalizingMinMax(double[] data){
    double value;
    double maxvalue = getMax(data);
    double minvalue = getMin(data);
    //if this column only has one value...skip it.
    if (Double.compare(maxvalue, minvalue) == 0) {
      System.out.println("Data has only one value: " + minvalue);
      return;
    }
    for (int i = 0; i < data.length; i++) {
      value = data[i];
      if (Double.isNaN(value))
        continue;
      data[i] = (value - minvalue) / (maxvalue - minvalue);
    }
    System.out.println("DATA IS NORMALIZED USING MIN-MAX. ");
  }

  public static void normalizingMeanStdDev(double[] data){
    double value;
    double mean = getMean(data);
    double stddev = getStdDev(data);
    //if this column only has one value...skip it.
    if (Double.compare(stddev, 0.0f) == 0) {
      System.out.println("Data has only one value: " + mean);
      return;
    }
    for (int i = 0; i < data.length; i++) {
      value = data[i];
      data[i] = (value - mean) / stddev;
    }
    System.out.println("DATA IS NORMALIZED USING MEAN-StdDEV. ");
  }

  public static double getSum(float[] values){
    double sum = 0;
    for (int i = 0; i < values.length; i++) {
        sum = sum + values[i];
    }
    return sum;
  }
  public static double getSum(double[] values){
    double sum = 0;
    for (int i = 0; i < values.length; i++) {
        sum = sum + values[i];
    }
    return sum;
  }

  public static int getSum(int[] values){
  int sum = 0;
  for (int i = 0; i < values.length; i++) {
      sum = sum + values[i];
  }
  return sum;
}

public static double getSum(float[] values, int begin_inc, int end_exc){
  double sum = 0;
  for (int i = begin_inc; i < end_exc; i++) {
      sum = sum + values[i];
  }
  return sum;
}
public static double getSum(double[] values, int begin_inc, int end_exc){
  double sum = 0;
  for (int i = begin_inc; i < end_exc; i++) {
      sum = sum + values[i];
  }
  return sum;
}

public static int getSum(int[] values, int begin_inc, int end_exc){
int sum = 0;
for (int i = begin_inc; i < end_exc; i++) {
    sum = sum + values[i];
}
return sum;
}


  public static double getMax(double[] values) {
    double max = Integer.MIN_VALUE;
    for (int i = 0; i < values.length; i++) {
      if(Double.isNaN(values[i]))
        continue;
      if (values[i] > max)
        max = values[i];
    }
    return max;
  }
  public static double getMin(double[] values) {
    double min = Integer.MAX_VALUE;
    for (int i = 0; i < values.length; i++) {
      if(Double.isNaN(values[i]))
        continue;
      if (values[i] < min)
        min = values[i];
    }
    return min;
  }


  /***
   * Returns the average value of the give array of numbers. If they are all NaN,
   * returns NaN. Otherwise, returns the average of all valid numbers.
   */
  public static double getMean(double[] values) {
  double mean = 0;
    int count = 0;
    for (int i = 0; i < values.length; i++) {
      if(Double.isNaN(values[i]))
        continue;
      mean = mean + values[i];
      count ++;
    }
    return mean / (float) (count);
  }

  /**
   * mean for range [min, max)
   * */
  public static double getMean(double[] data, double minInc, double maxExc) {
    double mean = 0;
    int count = 0;
    for (int i = 0; i < data.length; i++) {
      if(Double.isNaN(data[i]))
        continue;
      if (data[i] >= minInc && data[i] < maxExc) {
        mean = mean + data[i];
        count++;
      }
    }
    mean = mean / count;
    return mean;
  }

  /****
   * STDDEV = Math.sqrt((SUM(value-mean)^2) /(n-1));
   */
  public static double getStdDev(double[] values) {
    double mean = getMean(values);
    double stddev = 0;
    int count = 0;
    for (int i = 0; i < values.length; i++) {
      if (Double.isNaN(values[i]))
        continue;
      stddev = stddev + (values[i] - mean) * (values[i] - mean);
      count ++;
    }
    stddev = stddev / (float)(count -1 );
    stddev = Math.sqrt(stddev);
    return stddev;
  }

  public static double getEuclideanDistance(double[] vector1, double[] vector2){
    double result = 0;
    double temp;
    for (int i=0; i< vector1.length; i++){
      temp = (vector1[i] - vector2[i]);
      result = result + temp * temp;
    }
    return Math.sqrt(result);
  }

  public static double getEuclideanDistance(double[][] vector1, double[][] vector2){
    double result = 0;
    double temp;
    for (int r=0; r< vector1.length; r++){
      for (int k=0; k< vector1[0].length; k++){
        temp = (vector1[r][k] - vector2[r][k]);
        result = result + temp * temp;
      }
    }
    return Math.sqrt(result);
  }

  public static float getEuclideanDistance(float[] vector1, float[] vector2){
    float result = 0;
    float temp;
    for (int i=0; i< vector1.length; i++){
      temp = (vector1[i] - vector2[i]);
      result = result + temp * temp;
    }
    return (float) Math.sqrt(result);
  }
  /*
     There's a statistical function in Excel called NORMSDIST. It's used in calculating the values of options. It's obscure enough that I spent a lot of time figuring out how to duplicate it. Here's the function I wrote to do get an approximation accurate out to about eight decimal places:
   Public Shared Function StandardNormalCumulativeDistribution(ByVal x As Double) As Double
   Dim Z As Double = 1 / Sqrt(2.0 * System.Math.PI) * System.Math.Exp(-x ^ 2.0 / 2.0)
   Dim p As Double = 0.2316419
   Dim b1 As Double = 0.31938153
   Dim b2 As Double = -0.356563782
   Dim b3 As Double = 1.781477937
   Dim b4 As Double = -1.821255978
   Dim b5 As Double = 1.330274429
   Dim t As Double = 1.0 / (1.0 + p * x)

   Return 1.0 - Z * (b1 * t + b2 * t ^ 2.0 + b3 * t ^ 3.0 + b4 * t ^ 4.0 + b5 * t ^ 5.0)

   End Function
      }

   //modified version
   Dim x As Double = System.Math.Abs(y)
   Dim Z As Double = 1 / System.Math.Sqrt(2.0 * System.Math.PI) * System.Math.Exp(-x ^ 2.0 / 2.0)
   Dim p As Double = 0.2316419
   Dim b1 As Double = 0.31938153
   Dim b2 As Double = -0.356563782
   Dim b3 As Double = 1.781477937
   Dim b4 As Double = -1.821255978
   Dim b5 As Double = 1.330274429
   Dim t As Double = 1.0 / (1.0 + p * x)
   Dim Answer As Double = 1.0 - Z * (b1 * t + b2 * t ^ 2.0 + b3 * t ^ 3.0 + b4 * t ^ 4.0 + b5 * t ^ 5.0)
   If x <> y Then Answer = 1 - Answer

   */
  public static double getStdNormalCumulativeDistribution(double y) {
    double x = Math.abs(y);
    double Z = 1.0f /
        (Math.sqrt(2.0f * Math.PI) * Math.exp(Math.pow( -x, 2.0f) / 2.0));
    double p = 0.2316419;
    double b1 = 0.31938153;
    double b2 = -0.356563782;
    double b3 = 1.781477937;
    double b4 = -1.821255978;
    double b5 = 1.330274429;
    double t = 1.0 / (1.0 + p * x);

    double result = (1.0 -
                     Z *
                     (b1 * t + b2 * Math.pow(t, 2.0f) + b3 * Math.pow(t, 3.0f) +
                      b4 * Math.pow(t, 4.0f) + b5 * Math.pow(t, 5.0f)));
    if (x / y < 0)
      return (1 - result);
    else
      return result;
  }

  /**
   * The input is the cumulative probability, so it shoud be in range (0, 1)
   * **/
  public static final double MIN = -9999999;
  public static final double MAX =  9999999;
  public static double getStdNormalCumulativeInverse(double prob) {
    if (prob <0 || prob > 1)
      return Double.NaN;
    double min_prob = getStdNormalCumulativeDistribution(MIN);
    double max_prob = getStdNormalCumulativeDistribution(MAX);
    if (prob <= min_prob)
      return MIN;
    else if (prob >= max_prob)
      return MAX;

    return getStdNormalCumulativeInverseDivideAndConconquer(prob, MIN, MAX);
  }

  private static double epsilon = 0.000001f;
  private static double getStdNormalCumulativeInverseDivideAndConconquer(double prob, double min, double max){
    double midpoint = (min + max) /2.0;
    double val = getStdNormalCumulativeDistribution(midpoint);
    if (Math.abs(prob - val) < epsilon)
      return midpoint;
    else if (val < prob)
      return getStdNormalCumulativeInverseDivideAndConconquer(prob, midpoint, max);
    else
      return getStdNormalCumulativeInverseDivideAndConconquer(prob, min, midpoint);
  }

  /***
   * IN the input data, an element can be NaN value, which will be ignored. This allows
   * an easier implementation of outlier processing, where outliers can simply be set
   * as NaN value.
   */
  public static double[] regression(double[] y, double[] x){
    double[] coefficients = new double[3]; //a, b in y = a*x + b
    int numberPoints = y.length;
    double sumx = 0;
    double sumy = 0;
    double sumxx = 0;
    double sumyy = 0;
    double sumxy = 0;
    int countNaNvalues = 0;
    for (int i=0; i< numberPoints; i++){
      if (Double.isNaN(x[i]) || Double.isNaN(y[i])){
        countNaNvalues ++;
        continue;
      }
      sumx += x[i];
      sumy += y[i];
      sumxx += x[i] * x[i];
      sumyy += y[i] * y[i];
      sumxy += x[i] * y[i];
    }
    double n = (double) (numberPoints - countNaNvalues);

    double Sxx = n * sumxx - sumx * sumx;
    double Syy = n * sumyy - sumy * sumy;
    double Sxy = n * sumxy - sumx * sumy;
    double a = Sxy / Sxx;
    double b = (sumy - a * sumx) / n;
    double r2 = (Sxy*Sxy)/(Sxx*Syy);
    coefficients[0] = a;
    coefficients[1] = b;
    coefficients[2] = r2;
//    double ymean = sumy/n;
//    double SSR = 0;
//    double SST = 0;
//    for (int i=0; i< numberPoints; i++){
//      SSR += Math.pow(y[i] - (a * x[i] + b), 2);
//      SST += Math.pow(y[i] - ymean, 2);
//    }
//    System.out.println("r2= "+ r2 + ";\tanother calculation= "+ (1-SSR/SST));
    return coefficients;
  }

  public static double regressionR2(double[] y, double[] x){
    double[] coefficients = MathUtil.regression(y, x);
    double r2 = coefficients[2];
    return r2;
  }

  /**Linear Correlation
     The correlation coefficient, r is used to answer the question:
   Is a change in one of the independent varibles associated linearly with a change
   in the other independent variable? The correlation coefficient is calculated as:

   r = sum[(x - xmean)* (y - ymean)] / sqrt{[sum(x-xmean)^2 * sum(y-ymean)^2]}

   I.e.

   r = Covariance (x, y) / (StdDev(x) * StdDev (y))

   A value of r = 0.0 indicates no linear relationship between the two  variables,
   whereas a value of r = 1.0 or r = -1.0 suggests a strong linear relationship
   between the two variables. The correlation coefficient can only be used to
   determine if there is a linear relationship between two variables,
   it cannot be used to show that one variable is dependent on a second variable.
   */
  public static double getLinearCorrelation(double[] X, double[] Y){

    //STDDEV = Math.sqrt((SUM(value-mean)^2) / n-1);
    double xStdDev = MathUtil.getStdDev(X);
    double yStdDev = MathUtil.getStdDev(Y);
    double covariance = getCovariance(X, Y);

    return covariance / (xStdDev * yStdDev);
  }


  public static double getCovariance(double[] x, double[] y){
    double sum = 0;
    double xmean = getMean(x);
    double ymean = getMean(y);
    int count = 0;
    for (int i=0; i< x.length; i++){
      if (Double.isNaN(x[i]) || Double.isNaN(x[i]))
        continue;
      sum = sum + (x[i] - xmean)*(y[i] - ymean);
      count ++;
    }
    return sum/(double)(count); //should divide by (count) or (count -1)?
  }

  public static void main(String[] args){
    double[] y = new double[]{12, 34, 56, 57, 67, 78, 79};
    double[] x = new double[]{8, 39, 52, 50, 78, 71, 89};
    MathUtil.regression(y, x);
  }

  /** data[r][c][v] = data[r][c][v]/SUM(data[r][c]*/
  public static void convertToPercentageData(double[][][] data){
    double sum;
    for (int row = 0; row < data.length; row++)
      for (int col = 0; col < data[0].length; col++) {
        sum = MathUtil.getSum(data[row][col]);
        for (int d = 0; d < data[0][0].length; d++) {
          if (sum > 0)
            data[row][col][d] = data[row][col][d] / sum;
          else
            data[row][col][d] = data[row][col][d] / sum;
        }
      }
  }

  public static void convertToPercentageData(double[][] data){
    double sum;
    for (int row = 0; row < data.length; row++) {
      sum = MathUtil.getSum(data[row]);
      for (int d = 0; d < data[0].length; d++) {
        if (sum > 0)
          data[row][d] = data[row][d] / sum;
        else
          data[row][d] = data[row][d] / sum;
      }
    }
  }
}
