package edu.stanford.db.rdf.util;

import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import org.w3c.rdf.syntax.*;


public class StreamChopper extends Observable implements RDFConsumer {

  Model m; // collected stuff
  int max;

  RDFFactory f;

  public StreamChopper(RDFFactory f, int maxStmtPerModel) {

    this.f = f;
    this.max = maxStmtPerModel;
    m = f.createModel();
  }

  public void startModel() {}
  public void endModel() {}

  public NodeFactory getNodeFactory() {
    return f.getNodeFactory();
  }

  public void addStatement(Statement s) throws ModelException {
    
    m.add(s);
    if(m.size() >= max) {
      setChanged();
      notifyObservers(m);
      m = f.createModel();
    }
  }
}
