package org.ecoinformatics.seek.datasource;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.kepler.objectmanager.data.db.Constraint;
import org.kepler.objectmanager.data.db.PrimaryKey;
import org.kepler.objectmanager.data.db.UnWellFormedConstraintException;

/**
 * @author Jing Tao
 *
 */

public class TestPrimaryKey extends TestCase
{
  private PrimaryKey primaryKey = null;
  private String CONSTRAINTNAME = "primary_key";
  private String KEY1           = "id1";
  private String KEY2           = "id2";

  public TestPrimaryKey(String name)
  {
    super(name);
  }

  protected void setUp() throws Exception
  {
    super.setUp();
    primaryKey = new PrimaryKey();
    String constraintName = CONSTRAINTNAME;
    primaryKey.setName(constraintName);
  }

  protected void tearDown() throws Exception
  {
    primaryKey = null;
    super.tearDown();
  }

  public void testPrintStringHaveOneKey() throws UnWellFormedConstraintException
  {
    String[] keys = new String[1];
    keys[0] = KEY1;
    primaryKey.setKeys(keys);
    String expectedReturn = " "+ Constraint.CONSTRAINT + " "+CONSTRAINTNAME + " " +
                            Constraint.PRIMARYKEYSTRING + " "+"("+KEY1+")" +" ";
    String actualReturn = primaryKey.printString();
    assertEquals("return value", expectedReturn, actualReturn);

  }

  public void testPrintStringHaveTwoKeys() throws UnWellFormedConstraintException
  {
    String[] keys = new String[2];
    keys[0] = KEY1;
    keys[1] = KEY2;
    primaryKey.setKeys(keys);
    String expectedReturn = " "+ Constraint.CONSTRAINT + " "+CONSTRAINTNAME + " " +
                            Constraint.PRIMARYKEYSTRING + " "+"("+
                            KEY1 + "," + KEY2 + ")"+" ";
    String actualReturn = primaryKey.printString();
    assertEquals("return value", expectedReturn, actualReturn);

  }

  /**
  * Run an initial test that always passes to check that the test
  * harness is working.
  */
  public void initialize()
  {
    assertTrue(1 == 1);
  }


  /**
  * Create a suite of tests to be run together
  */
  public static Test suite()
  {
    TestSuite suite = new TestSuite();
    suite.addTest(new TestPrimaryKey("initialize"));
    suite.addTest(new TestPrimaryKey("testPrintStringHaveOneKey"));
    suite.addTest(new TestPrimaryKey("testPrintStringHaveTwoKeys"));
    return suite;
  }


}
